$Pref::Tremor::DevourRange = 15; //Don't change this unless you know what you're doing and are sure you want to do it.
$Pref::Tremor::MaximumTopple = 600;
$Pref::Tremor::ToppleTime = 20;
datablock TSShapeConstructor(tremorDts)
{
    baseShape  = "./tremor.dts";
    
    //- Default Animations -
    sequence0  = "./t_root2.dsq root";
    sequence1  = "./t_root2.dsq run";
    sequence2  = "./t_root2.dsq walk";
    sequence3  = "./t_root2.dsq back";
    sequence4  = "./t_root2.dsq side";
    sequence5  = "./t_Burrow.dsq burrow";
    sequence6  = "./t_Burrowmove.dsq burrowRun";
    sequence7  = "./t_Burrowmove.dsq burrowBack";
    sequence8  = "./t_Burrowmove.dsq burrowSide";
    sequence9  = "./t_look.dsq look";
    sequence10 = "./t_root2.dsq headside";
    sequence11 = "./t_root2.dsq headUp";
    sequence12 = "./t_root2.dsq jump";
    sequence13 = "./t_root2.dsq standjump";
    sequence14 = "./t_fall.dsq fall";
    sequence15 = "./t_root2.dsq land";
    sequence16 = "./t_root2.dsq armAttack";
    sequence17 = "./t_root2.dsq armReadyLeft";
    sequence18 = "./t_root2.dsq armReadyRight";
    sequence19 = "./t_root2.dsq armReadyBoth";
    sequence20 = "./t_root2.dsq spearready";  
    sequence21 = "./t_root2.dsq spearThrow";
    sequence22 = "./t_root2.dsq talk";  
    sequence23 = "./t_Death.dsq death1"; 
    sequence24 = "./t_root2.dsq shiftUp";
    sequence25 = "./t_root2.dsq shiftDown";
    sequence26 = "./t_root2.dsq shiftAway";
    sequence27 = "./t_root2.dsq shiftTo";
    sequence28 = "./t_root2.dsq shiftLeft";
    sequence29 = "./t_root2.dsq shiftRight";
    sequence30 = "./t_root2.dsq rotCW";
    sequence31 = "./t_root2.dsq rotCCW";
    sequence32 = "./t_root2.dsq undo";
    sequence33 = "./t_root2.dsq plant";
    sequence34 = "./t_root2.dsq sit";
    sequence35 = "./t_root2.dsq wrench";
    sequence36 = "./t_root2.dsq activate";
    sequence37 = "./t_root2.dsq activate2";
    sequence38 = "./t_root2.dsq leftrecoil";
    sequence39 = "./t_eat.dsq eat";
    sequence40 = "./t_bite.dsq bite";
    sequence41  = "./t_root2.dsq crouch";
    sequence42  = "./t_root2.dsq crouchRun";
    sequence43  = "./t_root2.dsq crouchBack";
    sequence44  = "./t_root2.dsq crouchSide";
};

datablock AudioProfile(TremorPainSound)
{
    fileName = "./tpain.wav";
    description = AudioClose3d;
    preload = true;
};

datablock AudioProfile(TremorDeathSound)
{
    fileName = "./tdeath.wav";
    description = AudioClose3d;
    preload = true;
};

datablock AudioProfile(TremorTongueGrab)
{
	fileName = "./tonguegrab.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(TremorBurrowSound)
{
	fileName = "./burrow.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(TremorUnburrowSound)
{
	fileName = "./unburrow.wav";
	description = AudioClose3d;
	preload = true;
};

datablock PlayerData(tremorArmor : PlayerStandardArmor)
{
     renderFirstPerson = true;
   emap = false;
   
   className = Armor;
   shapeFile = "./tremor.dts";
   cameraMaxDist = 20;
   cameraTilt = 0;//0.174 * 2.5; //~25 degrees
   cameraVerticalOffset = 0;
   computeCRC = false;
  
   canObserve = true;
   cmdCategory = "Clients";
   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/shapes/player/debris_player.dts";
   //debris = horseDebris;
   aiAvoidThis = true;
   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 3.0;
   mass = 65;
   drag = 0.1;
   maxdrag = 0.52;
   density = 0.7;
   maxDamage = 800;
   maxEnergy =  10;
   repairRate = 0.33;
   energyPerDamagePoint = 75.0;
   rechargeRate = 0.4;
   runForce = 50 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 3;
   maxBackwardSpeed = 1;
   maxSideSpeed = 1;
   mindustspeed= 10;
   maxForwardCrouchSpeed = 3;
   maxBackwardCrouchSpeed = 1;
   maxSideCrouchSpeed = 1;
   maxForwardProneSpeed = 0;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;
   maxForwardWalkSpeed = 1;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;
   maxUnderwaterForwardSpeed = 20;
   maxUnderwaterBackwardSpeed = 7.8;
   maxUnderwaterSideSpeed = 7.8;
   jumpForce = 0;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 5;
   minJetEnergy = 0;
    jetEnergyDrain = 0;
    canJet = 0;
   recoverDelay = 0;
   recoverRunForceScale = 1.2;
   minImpactSpeed = 250;
   speedDamageScale = 3.8;
   boundingBox            = vectorScale("6.0 18.0 6.0", 4); //"2.5 2.5 2.4";
   crouchBoundingBox    = vectorScale("6.0 18.0 6.0", 4); //"2.5 2.5 2.4";
   proneBoundingBox        = vectorScale("0.01 0.01 0.01", 1); //"2.5 2.5 2.4";
    useCustomPainEffects = true;
    PainSound            = tremorPainSound;
    DeathSound            = tremorDeathSound;
   pickupRadius = 0.75;
   
   // Damage location details
   boxNormalHeadPercentage       = 0.83;
   boxNormalTorsoPercentage      = 0.49;
   boxHeadLeftPercentage         = 0;
   boxHeadRightPercentage        = 1;
   boxHeadBackPercentage         = 0;
   boxHeadFrontPercentage        = 1;
   // Foot Prints
   //decalData   = HorseFootprint;
   //decalOffset = 0.25;
    
   jetEmitter = "";
   jetGroundEmitter = "";
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;
   //dustEmitter = LiftoffDustEmitter;
   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;
   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 65;
   jumpSurfaceAngle = 66;
   minJumpSpeed = 20;
   maxJumpSpeed = 30;
   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;
   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;
   //NOTE:  some sounds commented out until wav's are available
   JumpSound            = tremorJumpSound;
   // Footstep Sounds
//   FootSoftSound        = HorseFootFallSound;
//   FootHardSound        = HorseFootFallSound;
//   FootMetalSound       = HorseFootFallSound;
//   FootSnowSound        = HorseFootFallSound;
//   FootShallowSound     = HorseFootFallSound;
//   FootWadingSound      = HorseFootFallSound;
//   FootUnderwaterSound  = HorseFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;
   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   impactWaterEasy      = Splash1Sound;
   impactWaterMedium    = Splash1Sound;
   impactWaterHard      = Splash1Sound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;
   
   observeParameters = "0.5 4.5 4.5";
   // Inventory Items
    maxItems   = 10;    //total number of bricks you can carry
    maxWeapons = 0;        //this will be controlled by mini-game code
    maxTools = 0;
    
    uiName = "tremor";
    rideable = false;
        lookUpLimit = 0.1;
        lookDownLimit = 0.1;
   numMountPoints = 1;
   mountThread[0] = "root2";
   mountNode[0] = 0;
    canRide = false;
    showEnergyBar = false;
    paintable = true;
 
    brickImage = tremorBrickImage;    //the imageData to use for brick deployment
};


datablock PlayerData(TremorBurrowArmor : tremorArmor)
{
	boundingBox    = vectorScale("0.1 0.1 0.1", 4); //"2.5 2.5 2.4";
	crouchBoundingBox    = vectorScale("0.1 0.1 0.1", 4); //"2.5 2.5 2.4";
   	proneBoundingBox        = vectorScale("0.01 0.01 0.01", 1); //"2.5 2.5 2.4";
   	useCustomPainEffects = true;
    	PainSound            = tremorPainSound;
    	DeathSound            = tremorDeathSound;
   	pickupRadius = 0.75;
	uiname = "";
   	maxForwardSpeed = 40;
   	maxBackwardSpeed = 30;
   	maxSideSpeed = 30;
   	maxForwardCrouchSpeed = 40;
   	maxBackwardCrouchSpeed = 30;
   	maxSideCrouchSpeed = 30;
	uiName = "";
};

datablock ParticleData(TremorDirtParticle)
{
   dragCoefficient      = 5;
   gravityCoefficient   = 0.1;
   inheritedVelFactor   = 0.1;
   constantAcceleration = 0.0;
   lifetimeMS           = 3000;
   lifetimeVarianceMS   = 300;
   useInvAlpha          = true;
   textureName          = "base/data/particles/cloud";
   colors[0]     = "0.498 0.2 0 0.8";
   colors[1]     = "0.398 0.150 0 0.6";
   colors[2]     = "0.298 0.100 0 0.4";
   sizes[0]      = 14;
   sizes[1]      = 10;
   sizes[2]      = 6;
   times[0]      = 1.0;
   times[1]      = 0.2;
   times[2]      = 0.0;
};

datablock ParticleEmitterData(TremorDirtEmitter)
{
   ejectionPeriodMS = 60;
   periodVarianceMS = 5;
   ejectionVelocity = 2.5;
   ejectionOffset   = 0.5;
   velocityVariance = 0.2;
   thetaMin         = 80;
   thetaMax         = 80;
   phiReferenceVel  = 45;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TremorDirtParticle";

   uiName = "Tremor Dirt";
};

datablock ShapeBaseImageData(TremorDirtImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = $HeadSlot;

	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.01;

	stateName[1]					= "FireA";
	stateTransitionOnTimeout[1]		= "Done";
	stateWaitForTimeout[1]			= True;
	stateTimeoutValue[1]			= 0.350;
	stateEmitter[1]					= TremorDirtEmitter;
	stateEmitterTime[1]				= 0.350;

	stateName[2]					= "Done";
	stateScript[2]					= "onDone";
};
function TremorDirtImage::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}

