exec("./Player_Tremor.cs");

package tremor
{

	function Player::isTremor(%obj)
	{
		return (%obj.getDatablock().getName() $= "tremorArmor" || %obj.getDatablock().getName() $= "tremorBurrowArmor");
	}

	function endTrSchedule(%obj, %type, %thing)
	{
		if(%obj.isTremor())
		{
			switch$(%type)
			{
				case "tbs":
					cancel(%obj.tbs);
					%obj.tbs = 0;
				case "tbkt":
					cancel(%obj.tbkt);
					%obj.tbkt = 0;
				case "eating":
					if(%obj.getDatablock().getName() $= "tremorArmor")
						%obj.playThread(0, "root");
					else if(%obj.getdatablock().getname() $= "tremorBurrowArmor")
						%obj.playThread(0, "burrowRun");
				case "hoers":
					%obj.client.stomach[%thing.stomachSlot] = 0;
				case "endEatingEntirely":
					%obj.isEating = 0;
			}
		}
	}
				
    function Armor::onTrigger(%this, %player, %slot, %val)
    {
        if(%player.isTremor() && %slot $= 4 && %val && !%player.isDevouring)
        {
            %player.playThread(0, "bite");
	    serverPlay3D(TremorTongueGrab, %player.getPosition());
            %obj = %player.lookinfront($TypeMasks::PlayerObjectType, $Pref::Tremor::DevourRange);
	    %player.schedule(800,tGrab,%obj);
        }

	if(%player.isTremor() && %slot $= 2 && %val)
	{
		if(!%player.tbs && !%player.isEating)
		{
			if(!%player.burrow)
			{
				%player.playThread(0, "burrow");
				serverPlay3D(TremorBurrowSound, %player.getPosition());
				%player.emote(TremorDirtImage);
				%player.schedule(1500,setDatablock,"tremorBurrowArmor");
				%player.tbs = schedule(600, 0, endTrSchedule, %player, "tbs");
				%player.burrow = 1;
			}
			else if(%player.burrow)
			{
				%player.playThread(0, "root");
				serverPlay3D(TremorUnburrowSound, %player.getPosition());
				%player.emote(TremorDirtImage);
				%player.setDatablock("tremorArmor");
				%player.tbs = schedule(600, 0, endTrSchedule, %player, "tbs");
				%player.burrow = 0;
			}
		}
	}

	if(%player.isTremor() && %slot $= 3 && %val)
	{
		if(!%player.tbkt)
		{
			%obj = %player.lookInfront($TypeMasks::fxBrickObjectType, $Pref::Tremor::DevourRange);
			if(%obj.getClassName() $= "fxDTSBrick")
			{
				%obj.topple();
				%player.tbkt = schedule(2*60000, 0, endTrSchedule, %player, "tbkt");
				%player.tbks = 1;
			}
		}
		else
		{
			messageClient(%player.client, '', "You cannot topple structures yet!");
		}
	}
        parent::onTrigger(%this, %player, %slot, %val);
    }

    function Player::tGrab(%tremor, %obj)
    {
	if(%tremor.isTremor() && isObject(%obj))
	{
                if(%obj != %this && (%obj.getClassName() $= "Player" || %obj.getDatablock().getName() $= "horseArmor"))
                    %tremor.devour(%obj);
	}
    }
    function Player::devour(%tremor, %obj)
    {
        if(!%obj.isBD && %tremor.isTremor() && isObject(%obj) && isObject(%tremor) && %obj.getDatablock().getName() !$= "tremorarmor" && !%tremor.isDevouring)
        {
		if(%obj.getClassName() $= "Player" && %tremor.client.minigame != 0 && %tremor.client.minigame == %obj.client.minigame)
		{
			schedule(1200, 0, serverCmdUnUseTool, %obj.client);
	   	 	%tremor.isDevouring = 1;
			%tremor.isEating = 1;
            		%tremor.mountObject(%obj, 1);
            		%tremor.playThread(0, "eat");
	    		%tremor.client.stomach[%tremor.client.stomachCt++] = %obj;
	    		%obj.isBD = 1;
	    		%obj.canDismount = 0;
			%obj.stomachSlot = %tremor.client.stomachCt;
			%tremor.schedule(1200, mountObject, %obj, 2);
			%obj.schedule(1200, setPlayerScale, "0.7 0.7 0.7");
            		%obj.tremorKill = %obj.schedule(7000, tkill, %tremor);
			schedule(7000, 0, endTrSchedule, %tremor, "endEatingEntirely");
            		schedule(1200, 0, endTrSchedule, %tremor, "eating");
	   		%tremor.schedule(4200,endDevour);
		}
		else if(%obj.getDatablock().getName() $= "horseArmor")
		{
			if(%obj.getMountedObject(0) != 0)
			{
				%rider = %obj.getMountedObject(0);
				%rider.dismount();
				%rider.addVelocity("0 0 10");
			}
	   	 	%tremor.isDevouring = 1;
            		%tremor.mountObject(%obj, 1);
            		%tremor.playThread(0, "eat");
	    		%tremor.client.stomach[%tremor.client.stomachCt++] = %obj;
	    		%obj.isBD = 1;
			%obj.stomachSlot = %tremor.client.stomachCt;
			%tremor.schedule(1200, mountObject, %obj, 2);
            		%obj.tremorKill = %obj.schedule(7001, kill);
			schedule(7000, endTrSchedule, %tremor, "hoers", %obj);
			%obj.removeBody();
			schedule(7000, 0, endTrSchedule, %tremor, "endEatingEntirely");
            		schedule(1200, 0, endTrSchedule, %tremor, "eating");
	   		%tremor.schedule(4200,endDevour);
		}
        }
    }

	function Player::tKill(%obj, %killer)
	{
		messageAll('',%killer.client.getplayername()@" devoured "@%obj.client.getplayername()@"!");
		%killer.client.stomach[%obj.stomachSlot] = 0;
		%obj.damage(%killer, %obj.getWorldBoxCenter(), %obj.getDatablock().maxDamage*2);
		%obj.removeBody();
		%killer.client.score += 1;
	}

    function Player::endDevour(%player)
    {
	if(%player.isTremor() && %player.isDevouring)
		%player.isDevouring = 0;
    }

	function gameConnection::onDeath(%client, %killerPlayer, %killer, %damageType, %damageLoc)
	{
		parent::onDeath(%client, %killerPlayer, %killer, %damageType, %damageLoc);
		if(%client.stomachCt != 0)
		{
			for(%s = 0; %s < %client.stomachCt; %s++)
			{
				%stomach = %client.stomach[%s];
				if(%stomach.tremorKill != 0)
				{
					cancel(%stomach.tremorKill);
					%stomach.canDismount = 1;
					%stomach.dismount();
					%stomach.setPlayerScale("1 1 1");
					%stomach.addVelocity("0 0 10");
					%killer.score += 1;
					messageAll('',"\c3"@%killer.getPlayerName()@"\c5 saved \c3"@%stomach.client.getplayername()@"\c5 from a tremor! (+1 Point)");
					%stomach.isBD = 0;
				
				}
			}
			for(%i = 1; %i < %client.stomachCt; %i++)
				%client.stomach[%i] = 0;
			%client.stomachCt = 0;
		}
	}

	function fxDTSBrick::topple(%obj)
	{
		%this = new scriptObject(){start = %obj; ct = 1; queue[1] = %obj;};
		%max = $Pref::Tremor::MaximumTopple;
		for(%i = 0; %i < %max; %i++)
		{
			if(%this.ct >= %max)
				break;

			%obj = %this.queue[%i];
			if(%i > 0)
			{
				for(%down = 0; %down < %obj.getNumDownBricks(); %down++)
				{
					%d = %obj.getDownBrick(%down);
					if(!%this.bool[%d])
					{
						%this.bool[%d] = 1;
						%this.queue[%this.ct++] = %d;
					}
				}
			}
			for(%up = 0; %up < %obj.getNumUpBricks(); %up++)
			{
				%u = %obj.getUpBrick(%up);
				if(!%this.bool[%u])
				{
					%this.bool[%u] = 1;
					%this.queue[%this.ct++] = %u;
				}
			}
		}
		for(%l = 1; %l < %this.ct; %l++)
			%this.queue[%l].schedule(0, fakeKillBrick, "0 0 0", $Pref::Tremor::ToppleTime);
		%this.delete();
	}

	function serverCmdUseTool(%client, %slot)
	{
		if(%client.player.stomachSlot > 0)
			return;
		parent::serverCmdUseTool(%client, %slot);
	}
};
activatepackage(tremor);
function Player::lookInfront(%obj, %typemask, %range)
{
    return containerRayCast(%obj.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%obj.getEyeVector()), %range), %obj.getEyePoint()), %typemask, %obj);
}

